# Design Proposals

This folder contains documents/links used to design new features for Kubeapps.

# Links

- Authentication (AuthN) and Authorization (AuthZ):
  - [Introduction](./authentication-and-authorization.md)
  - [OAuth 2 - OpenID Connect (OIDC) Support](https://docs.google.com/document/d/1YZzLtIbS2copQJgspFiMd0eAhpyt8u19MUSDEvH2X4g)
- Dashboard:
  - [Dashboard Error Handling](./dashboard/error-handling/error-handling.md)
  - [Simpler deployments](./dashboard/deployment-improvements.md)
  - [Improve UX in application view](./dashboard/application-view-revamp.md)
  - [Upgrade to Clarity design](./clarity-ui.md)
- [Notify Available Chart Updates](https://docs.google.com/document/d/1oG9nerd5CurWSIwH33kKCsOCtkSFMgcm8SuTJyuSnxs/)
- [Operators support](./operators-support-poc.md)
- [Third party integration for adding a chart repository](./third-party-add-repository.md)
- [Replacing MongoDB support](./replacing-mongodb.md)
- [Helm 3 support](./helm3.md)
- [Multicluster support](./multi-cluster-support.md)
